diff --git a/src/compile.cpp b/src/compile.cpp
index bd5234d..d92fb27 100644
--- a/src/compile.cpp
+++ b/src/compile.cpp
@@ -63,7 +63,7 @@ const bool DebugNatives = false;
 const bool DebugCallTable = false;
 const bool DebugMethodTree = false;
 const bool DebugFrameMaps = false;
-const bool DebugInstructions = false;
+const bool DebugInstructions = true;
 
 const bool CheckArrayBounds = true;
 
@@ -1466,6 +1466,7 @@ class Frame {
   void set(unsigned index, ir::Type type)
   {
     assertT(t, index < frameSize());
+    //assertT(t, type.flavor() != ir::Type::Float);
 
     if (type == ir::Type::object()) {
       context->eventLog.append(MarkEvent);
@@ -1648,6 +1649,7 @@ class Frame {
 
   void storeLarge(ir::Type type, unsigned index)
   {
+    assertT(t, type == ir::Type::i8() || type == ir::Type::f8());
     storeLocal(context, 2, type, popLarge(type), index);
     unsigned ti = translateLocalIndex(context, 2, index);
     assertT(t, ti + 1 < localSize());
@@ -1691,7 +1693,7 @@ class Frame {
   {
     ir::Value* s0 = c->pop(ir::Type::i4());
 
-    if (get(sp - 2) == ir::Type::i8()) {
+    if (get(sp - 2) == ir::Type::i8() || get(sp - 2) == ir::Type::f8()) {
       ir::Value* s1 = c->pop(ir::Type::i8());
 
       c->push(ir::Type::i4(), s0);
@@ -1724,7 +1726,7 @@ class Frame {
 
   void dup2()
   {
-    if (get(sp - 1) == ir::Type::i8()) {
+    if (get(sp - 1) == ir::Type::i8() || get(sp - 1) == ir::Type::f8()) {
       c->push(ir::Type::i8(), c->peek(2, 0));
     } else {
       ir::Value* s0 = c->pop(ir::Type::i4());
@@ -1750,7 +1752,7 @@ class Frame {
 
   void dup2X1()
   {
-    if (get(sp - 1) == ir::Type::i8()) {
+    if (get(sp - 1) == ir::Type::i8() || get(sp - 1) == ir::Type::f8()) {
       ir::Value* s0 = c->pop(ir::Type::i8());
       ir::Value* s1 = c->pop(ir::Type::i4());
 
@@ -1787,10 +1789,10 @@ class Frame {
 
   void dup2X2()
   {
-    if (get(sp - 1) == ir::Type::i8()) {
+    if (get(sp - 1) == ir::Type::i8() || get(sp - 1) == ir::Type::f8()) {
       ir::Value* s0 = c->pop(ir::Type::i8());
 
-      if (get(sp - 3) == ir::Type::i8()) {
+      if (get(sp - 3) == ir::Type::i8() || get(sp - 3) == ir::Type::f8()) {
         ir::Value* s1 = c->pop(ir::Type::i8());
 
         c->push(ir::Type::i8(), s0);
